﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Drawing;

namespace HKFmonitor
{
    public class TCPclient
    {
        //bool recComplete = false;
        public bool connected = false;
        public string status = "-";
        Configuration conf;

        public TCPclient(Configuration conf)
        {
            this.conf = conf;
        }

        internal string getListSync(string command, string address)
        {
            try
            {
                Socket soc = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                soc.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 5000);
                soc.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 5000);

                IAsyncResult result = soc.BeginConnect(IPAddress.Parse(address), conf.serverPort, null, null);

                bool success = result.AsyncWaitHandle.WaitOne(5000, true);
                if (!soc.Connected)
                {
                    return null;
                }

                byte[] buffer = Encoding.GetEncoding(1250).GetBytes(command);
                soc.Send(buffer);
                byte[] incoming = new byte[262144];
                int incLength = soc.Receive(incoming);
                string message = Encoding.GetEncoding(1250).GetString(incoming, 0, incLength);
                System.Threading.Thread.Sleep(30);

                while (soc.Available > 0)
                {

                    incLength = soc.Receive(incoming);
                    message += Encoding.GetEncoding(1250).GetString(incoming, 0, incLength);
                    System.Threading.Thread.Sleep(50);
                }
                soc.Close();
                string response = message;

                string tmp = response;
                if (tmp == "-;-;") tmp = ";";
                //recComplete = false;
                response = "";
                if (tmp.EndsWith(";")) tmp = tmp.Substring(0, tmp.Length - 1);
                return tmp;
            }
            catch (Exception)
            {
                return null;
            }
        }

    }
}
